/************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 *
 * Copyright 2008, 2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Use is subject to license terms.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0. You can also
 * obtain a copy of the License at http://odftoolkit.org/docs/license.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************************/

// !!! GENERATED SOURCE CODE !!!
package org.odftoolkit.odfdom.dom.style.props;

import org.odftoolkit.odfdom.pkg.OdfNamespace;
import org.odftoolkit.odfdom.pkg.OdfName;
import org.odftoolkit.odfdom.dom.OdfDocumentNamespace;

public interface OdfGraphicProperties {
	public final static OdfStyleProperty AmbientColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "ambient-color"));
	public final static OdfStyleProperty BackScale =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "back-scale"));
	public final static OdfStyleProperty BackfaceCulling =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "backface-culling"));
	public final static OdfStyleProperty CloseBack =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "close-back"));
	public final static OdfStyleProperty CloseFront =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "close-front"));
	public final static OdfStyleProperty Depth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "depth"));
	public final static OdfStyleProperty DiffuseColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "diffuse-color"));
	public final static OdfStyleProperty EdgeRounding =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "edge-rounding"));
	public final static OdfStyleProperty EdgeRoundingMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "edge-rounding-mode"));
	public final static OdfStyleProperty EmissiveColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "emissive-color"));
	public final static OdfStyleProperty EndAngle =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "end-angle"));
	public final static OdfStyleProperty HorizontalSegments =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "horizontal-segments"));
	public final static OdfStyleProperty LightingMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "lighting-mode"));
	public final static OdfStyleProperty NormalsDirection =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "normals-direction"));
	public final static OdfStyleProperty NormalsKind =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "normals-kind"));
	public final static OdfStyleProperty Dr3dShadow =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "shadow"));
	public final static OdfStyleProperty Shininess =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "shininess"));
	public final static OdfStyleProperty SpecularColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "specular-color"));
	public final static OdfStyleProperty TextureFilter =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "texture-filter"));
	public final static OdfStyleProperty TextureGenerationModeX =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "texture-generation-mode-x"));
	public final static OdfStyleProperty TextureGenerationModeY =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "texture-generation-mode-y"));
	public final static OdfStyleProperty TextureKind =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "texture-kind"));
	public final static OdfStyleProperty TextureMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "texture-mode"));
	public final static OdfStyleProperty VerticalSegments =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DR3D, "vertical-segments"));
	public final static OdfStyleProperty AutoGrowHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "auto-grow-height"));
	public final static OdfStyleProperty AutoGrowWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "auto-grow-width"));
	public final static OdfStyleProperty Blue =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "blue"));
	public final static OdfStyleProperty CaptionAngle =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-angle"));
	public final static OdfStyleProperty CaptionAngleType =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-angle-type"));
	public final static OdfStyleProperty CaptionEscape =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-escape"));
	public final static OdfStyleProperty CaptionEscapeDirection =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-escape-direction"));
	public final static OdfStyleProperty CaptionFitLineLength =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-fit-line-length"));
	public final static OdfStyleProperty CaptionGap =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-gap"));
	public final static OdfStyleProperty CaptionLineLength =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-line-length"));
	public final static OdfStyleProperty CaptionType =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "caption-type"));
	public final static OdfStyleProperty ColorInversion =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "color-inversion"));
	public final static OdfStyleProperty ColorMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "color-mode"));
	public final static OdfStyleProperty Contrast =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "contrast"));
	public final static OdfStyleProperty DecimalPlaces =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "decimal-places"));
	public final static OdfStyleProperty DrawAspect =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "draw-aspect"));
	public final static OdfStyleProperty EndGuide =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "end-guide"));
	public final static OdfStyleProperty EndLineSpacingHorizontal =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "end-line-spacing-horizontal"));
	public final static OdfStyleProperty EndLineSpacingVertical =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "end-line-spacing-vertical"));
	public final static OdfStyleProperty Fill =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill"));
	public final static OdfStyleProperty FillColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-color"));
	public final static OdfStyleProperty FillGradientName =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-gradient-name"));
	public final static OdfStyleProperty FillHatchName =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-hatch-name"));
	public final static OdfStyleProperty FillHatchSolid =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-hatch-solid"));
	public final static OdfStyleProperty FillImageHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-height"));
	public final static OdfStyleProperty FillImageName =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-name"));
	public final static OdfStyleProperty FillImageRefPoint =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-ref-point"));
	public final static OdfStyleProperty FillImageRefPointX =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-ref-point-x"));
	public final static OdfStyleProperty FillImageRefPointY =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-ref-point-y"));
	public final static OdfStyleProperty FillImageWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fill-image-width"));
	public final static OdfStyleProperty FitToContour =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fit-to-contour"));
	public final static OdfStyleProperty FitToSize =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "fit-to-size"));
	public final static OdfStyleProperty FrameDisplayBorder =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "frame-display-border"));
	public final static OdfStyleProperty FrameDisplayScrollbar =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "frame-display-scrollbar"));
	public final static OdfStyleProperty FrameMarginHorizontal =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "frame-margin-horizontal"));
	public final static OdfStyleProperty FrameMarginVertical =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "frame-margin-vertical"));
	public final static OdfStyleProperty Gamma =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "gamma"));
	public final static OdfStyleProperty GradientStepCount =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "gradient-step-count"));
	public final static OdfStyleProperty Green =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "green"));
	public final static OdfStyleProperty GuideDistance =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "guide-distance"));
	public final static OdfStyleProperty GuideOverhang =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "guide-overhang"));
	public final static OdfStyleProperty ImageOpacity =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "image-opacity"));
	public final static OdfStyleProperty LineDistance =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "line-distance"));
	public final static OdfStyleProperty Luminance =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "luminance"));
	public final static OdfStyleProperty MarkerEnd =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-end"));
	public final static OdfStyleProperty MarkerEndCenter =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-end-center"));
	public final static OdfStyleProperty MarkerEndWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-end-width"));
	public final static OdfStyleProperty MarkerStart =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-start"));
	public final static OdfStyleProperty MarkerStartCenter =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-start-center"));
	public final static OdfStyleProperty MarkerStartWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "marker-start-width"));
	public final static OdfStyleProperty MeasureAlign =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "measure-align"));
	public final static OdfStyleProperty MeasureVerticalAlign =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "measure-vertical-align"));
	public final static OdfStyleProperty OleDrawAspect =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "ole-draw-aspect"));
	public final static OdfStyleProperty Opacity =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "opacity"));
	public final static OdfStyleProperty OpacityName =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "opacity-name"));
	public final static OdfStyleProperty Parallel =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "parallel"));
	public final static OdfStyleProperty Placing =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "placing"));
	public final static OdfStyleProperty Red =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "red"));
	public final static OdfStyleProperty SecondaryFillColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "secondary-fill-color"));
	public final static OdfStyleProperty DrawShadow =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "shadow"));
	public final static OdfStyleProperty ShadowColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "shadow-color"));
	public final static OdfStyleProperty ShadowOffsetX =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "shadow-offset-x"));
	public final static OdfStyleProperty ShadowOffsetY =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "shadow-offset-y"));
	public final static OdfStyleProperty ShadowOpacity =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "shadow-opacity"));
	public final static OdfStyleProperty ShowUnit =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "show-unit"));
	public final static OdfStyleProperty StartGuide =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "start-guide"));
	public final static OdfStyleProperty StartLineSpacingHorizontal =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "start-line-spacing-horizontal"));
	public final static OdfStyleProperty StartLineSpacingVertical =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "start-line-spacing-vertical"));
	public final static OdfStyleProperty Stroke =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "stroke"));
	public final static OdfStyleProperty StrokeDash =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "stroke-dash"));
	public final static OdfStyleProperty StrokeDashNames =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "stroke-dash-names"));
	public final static OdfStyleProperty StrokeLinejoin =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "stroke-linejoin"));
	public final static OdfStyleProperty SymbolColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "symbol-color"));
	public final static OdfStyleProperty TextareaHorizontalAlign =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "textarea-horizontal-align"));
	public final static OdfStyleProperty TextareaVerticalAlign =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "textarea-vertical-align"));
	public final static OdfStyleProperty TileRepeatOffset =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "tile-repeat-offset"));
	public final static OdfStyleProperty Unit =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "unit"));
	public final static OdfStyleProperty VisibleAreaHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "visible-area-height"));
	public final static OdfStyleProperty VisibleAreaLeft =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "visible-area-left"));
	public final static OdfStyleProperty VisibleAreaTop =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "visible-area-top"));
	public final static OdfStyleProperty VisibleAreaWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "visible-area-width"));
	public final static OdfStyleProperty WrapInfluenceOnPosition =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.DRAW, "wrap-influence-on-position"));
	public final static OdfStyleProperty BackgroundColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "background-color"));
	public final static OdfStyleProperty Border =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "border"));
	public final static OdfStyleProperty BorderBottom =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "border-bottom"));
	public final static OdfStyleProperty BorderLeft =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "border-left"));
	public final static OdfStyleProperty BorderRight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "border-right"));
	public final static OdfStyleProperty BorderTop =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "border-top"));
	public final static OdfStyleProperty Clip =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "clip"));
	public final static OdfStyleProperty Margin =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "margin"));
	public final static OdfStyleProperty MarginBottom =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "margin-bottom"));
	public final static OdfStyleProperty MarginLeft =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "margin-left"));
	public final static OdfStyleProperty MarginRight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "margin-right"));
	public final static OdfStyleProperty MarginTop =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "margin-top"));
	public final static OdfStyleProperty MaxHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "max-height"));
	public final static OdfStyleProperty MaxWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "max-width"));
	public final static OdfStyleProperty MinHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "min-height"));
	public final static OdfStyleProperty MinWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "min-width"));
	public final static OdfStyleProperty Padding =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "padding"));
	public final static OdfStyleProperty PaddingBottom =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "padding-bottom"));
	public final static OdfStyleProperty PaddingLeft =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "padding-left"));
	public final static OdfStyleProperty PaddingRight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "padding-right"));
	public final static OdfStyleProperty PaddingTop =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "padding-top"));
	public final static OdfStyleProperty WrapOption =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.FO, "wrap-option"));
	public final static OdfStyleProperty BackgroundTransparency =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "background-transparency"));
	public final static OdfStyleProperty BorderLineWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "border-line-width"));
	public final static OdfStyleProperty BorderLineWidthBottom =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "border-line-width-bottom"));
	public final static OdfStyleProperty BorderLineWidthLeft =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "border-line-width-left"));
	public final static OdfStyleProperty BorderLineWidthRight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "border-line-width-right"));
	public final static OdfStyleProperty BorderLineWidthTop =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "border-line-width-top"));
	public final static OdfStyleProperty Editable =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "editable"));
	public final static OdfStyleProperty FlowWithText =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "flow-with-text"));
	public final static OdfStyleProperty HorizontalPos =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "horizontal-pos"));
	public final static OdfStyleProperty HorizontalRel =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "horizontal-rel"));
	public final static OdfStyleProperty Mirror =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "mirror"));
	public final static OdfStyleProperty NumberWrappedParagraphs =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "number-wrapped-paragraphs"));
	public final static OdfStyleProperty OverflowBehavior =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "overflow-behavior"));
	public final static OdfStyleProperty PrintContent =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "print-content"));
	public final static OdfStyleProperty Protect =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "protect"));
	public final static OdfStyleProperty RelHeight =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "rel-height"));
	public final static OdfStyleProperty RelWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "rel-width"));
	public final static OdfStyleProperty Repeat =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "repeat"));
	public final static OdfStyleProperty RunThrough =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "run-through"));
	public final static OdfStyleProperty StyleShadow =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "shadow"));
	public final static OdfStyleProperty ShrinkToFit =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "shrink-to-fit"));
	public final static OdfStyleProperty VerticalPos =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "vertical-pos"));
	public final static OdfStyleProperty VerticalRel =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "vertical-rel"));
	public final static OdfStyleProperty Wrap =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "wrap"));
	public final static OdfStyleProperty WrapContour =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "wrap-contour"));
	public final static OdfStyleProperty WrapContourMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "wrap-contour-mode"));
	public final static OdfStyleProperty WrapDynamicThreshold =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "wrap-dynamic-threshold"));
	public final static OdfStyleProperty WritingMode =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.STYLE, "writing-mode"));
	public final static OdfStyleProperty FillRule =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "fill-rule"));
	public final static OdfStyleProperty Height =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "height"));
	public final static OdfStyleProperty StrokeColor =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "stroke-color"));
	public final static OdfStyleProperty StrokeLinecap =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "stroke-linecap"));
	public final static OdfStyleProperty StrokeOpacity =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "stroke-opacity"));
	public final static OdfStyleProperty StrokeWidth =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "stroke-width"));
	public final static OdfStyleProperty Width =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "width"));
	public final static OdfStyleProperty X =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "x"));
	public final static OdfStyleProperty Y =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.SVG, "y"));
	public final static OdfStyleProperty AnchorPageNumber =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "anchor-page-number"));
	public final static OdfStyleProperty AnchorType =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "anchor-type"));
	public final static OdfStyleProperty Animation =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation"));
	public final static OdfStyleProperty AnimationDelay =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-delay"));
	public final static OdfStyleProperty AnimationDirection =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-direction"));
	public final static OdfStyleProperty AnimationRepeat =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-repeat"));
	public final static OdfStyleProperty AnimationStartInside =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-start-inside"));
	public final static OdfStyleProperty AnimationSteps =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-steps"));
	public final static OdfStyleProperty AnimationStopInside =
		OdfStyleProperty.get(OdfStylePropertiesSet.GraphicProperties, OdfName.newName(OdfDocumentNamespace.TEXT, "animation-stop-inside"));
}
